# -*- coding: utf-8 -*-

import random
import time

N = 1000
#generate random numbers

a = [0] * N
for i in range(N): 
    a[i] = random.randint(0, 1)
print("List generated")


#linear time version -- see https://en.wikipedia.org/wiki/Maximum_subarray_problem
t0 = time.clock()
max_so_far = 0
max_ending_here = 0
for v in a:
    max_ending_here = max(0, max_ending_here + v)
    max_so_far = max(max_so_far, max_ending_here)    	
print("Max subsequence sum = ", max_so_far)
print("Elapsed time (s): ",  time.clock() - t0)
